package singleton.audio;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

public class AudioPlayer {
    
    private static AudioPlayer instance = null;
    
    private AudioPlayer() {}
    
    public static AudioPlayer getInstance() {
        if ( instance == null )
            instance = new AudioPlayer();
        return instance;
    }
        
    public void play( String arquivoAudio ) throws Exception {                            
        try {
            InputStream in = new FileInputStream( arquivoAudio );
            InputStream bufIn = new BufferedInputStream( in );
                        
            AudioInputStream ain = AudioSystem.getAudioInputStream( bufIn );
            Clip clip = AudioSystem.getClip();           
            clip.open( ain );            
            clip.start();  
            
            Thread.sleep( clip.getMicrosecondLength() / 1000 ); 
            
            clip.close();            
        } catch ( UnsupportedAudioFileException ex ) {            
            throw new Exception( "Formato de arquivo de áudio não suportado." );
        } catch ( LineUnavailableException ex ) {     
            throw new Exception( "Erro na abertura do arquivo de áudio." );        
        } catch ( FileNotFoundException ex ) {
            throw new Exception( "\""+arquivoAudio+"\"\nArquivo não encontrado." );
        } catch ( IOException ex ) {            
            throw new Exception( "Erro na leitura do arquivo de áudio." );
        }
    }
            
}
